//
//  TDLevelLayer.h
//  Viral Zombies TD
//
//  Created by Yo on 23/11/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "cocos2d.h"

#import "Creep.h"
#import "Projectile.h"
#import "Tower.h"
#import "WayPoint.h"
#import "Wave.h"

#import "GameHUD.h"

@interface TDLevelLayer : CCLayer{
    CCTMXTiledMap *_tileMap;
    CCTMXLayer *_background;	
	
	double _difficulty;
	int _currentLevel;
	int _currentWave;
    bool _isPause;
    double _maxScore;
	
    
    CCLabelTTF *labelScore;
    CCLabelTTF *labelCoins;
    CCLabelTTF *labelHP;
    CCLayer *PauseMenuLayer;
    CCMenu *gameMenu;
    CCMenu *pauseMenu;
	GameHUD *gameHUD;
}

@property (nonatomic, retain) CCTMXTiledMap *tileMap;
@property (nonatomic, retain) CCTMXLayer *background;

@property (nonatomic, assign) double difficulty;
@property (nonatomic, assign) int currentLevel;
@property (nonatomic, assign) int currentWave;
@property (nonatomic, assign) bool isPause;
@property (nonatomic, assign) double maxScore;

- (void)displayScoreCoins;
- (void)addWaypoint;
- (void)addTower: (CGPoint)pos;
- (BOOL) canBuildOnTilePosition:(CGPoint) pos;

@end
