//
//  CreditsLayer.m
//  SpaceViking
//
//  Created by Rod on 9/18/10.
//  Copyright 2010 Prop Group LLC - www.prop-group.com. All rights reserved.
//

#import "HighScoresLayer.h"


@implementation HighScoresLayer

-(void)returnToMenu {
	[[GameManager sharedGameManager] runSceneWithID:kMainMenuScene];
}

-(void)resetScores {
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    [defaults setDouble:0.0 forKey:@"HighScores"];
	[[GameManager sharedGameManager] runSceneWithID:kHighScoresScene];
}

-(id)init {
	self = [super init];
	if (self != nil) {
		CGSize screenSize = [CCDirector sharedDirector].winSize; 
		CCSprite *background = [CCSprite spriteWithFile:@"GenericMenuBackground.png"];
		[background setPosition:ccp(screenSize.width/2, screenSize.height/2)];
		[self addChild:background];
        
        CCLabelBMFont *texLabelText = [CCLabelBMFont labelWithString:@"High Score" fntFile:@"VikingSpeechFont64.fnt"];
		CCMenuItemLabel *tex = [CCMenuItemLabel itemWithLabel:texLabelText target:self selector:nil];
        
        NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
        int currentHighScore = [defaults integerForKey:@"HighScores"];
        NSString *test =   [NSString stringWithFormat:@"%d",currentHighScore];
		CCLabelBMFont *scoLabelText = [CCLabelBMFont labelWithString:test fntFile:@"VikingSpeechFont64.fnt"];
		CCMenuItemLabel *sco = [CCMenuItemLabel itemWithLabel:scoLabelText target:self selector:nil];
        
        CCLabelBMFont *resetLabelText = [CCLabelBMFont labelWithString:@"Reset" fntFile:@"VikingSpeechFont64.fnt"];
		CCMenuItemLabel *resetLabel = [CCMenuItemLabel itemWithLabel:resetLabelText target:self selector:@selector(resetScores)];
        
		CCLabelBMFont *backLabelText = [CCLabelBMFont labelWithString:@"Back" fntFile:@"VikingSpeechFont64.fnt"];
		CCMenuItemLabel *backLabel = [CCMenuItemLabel itemWithLabel:backLabelText target:self selector:@selector(returnToMenu)];
	
		
		
		CCMenu *optionsMenu = [CCMenu menuWithItems:
							   tex,sco,resetLabel,backLabel,nil];
		
        [optionsMenu alignItemsInColumns:
         [NSNumber numberWithUnsignedInt:1],
         [NSNumber numberWithUnsignedInt:1],
         [NSNumber numberWithUnsignedInt:2],
         nil
         ];
        
		[optionsMenu setPosition:ccp(screenSize.width /2, screenSize.height /2)];
		[self addChild:optionsMenu];
        
        //[defaults setint:0 forKey:@"HighScores"];
        
	}
	return self;
}

@end
