//
//  MainMenuLayer.m
//  Viral Zombies TD
//
//  Created by Yo on 03/11/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "MainMenuLayer.h"
@interface MainMenuLayer() 
-(void)displayMainMenu;
-(void)displaySceneSelection;
@end

@implementation MainMenuLayer
-(void)showCredits {
    //link
    //[[GameManager sharedGameManager]
    //openSiteWithLinkType:kLinkTypeBookSite];
    CCLOG(@"Show the Credits screen");
    [[GameManager sharedGameManager] runSceneWithID:kCreditsScene];
}

-(void)showOptions {
    CCLOG(@"Show the Options screen");
    [[GameManager sharedGameManager] runSceneWithID:kOptionsScene];
}

-(void)showScores {
    CCLOG(@"Show the HighScires screen");
    [[GameManager sharedGameManager] runSceneWithID:kHighScoresScene];
}

-(void)playScene:(CCMenuItemFont*)itemPassedIn {
    if ([itemPassedIn tag] == 1) {
        [[GameManager sharedGameManager] runSceneWithID:kGameLevel1];
    } else if ([itemPassedIn tag] == 2) {
        [[GameManager sharedGameManager] runSceneWithID:kGameLevel2];
    } else if ([itemPassedIn tag] == 3) {
        [[GameManager sharedGameManager] runSceneWithID:kGameLevel3];
    } else {
        CCLOG(@"Unexpected item.  Tag was: %d", [itemPassedIn tag]);
    }
}

-(void)displayMainMenu {
    CGSize screenSize = [CCDirector sharedDirector].winSize; 
    if (sceneSelectMenu != nil) {
        [sceneSelectMenu removeFromParentAndCleanup:YES];
    }
    // Main Menu
    CCMenuItemImage *playGameButton = [CCMenuItemImage 
                                       itemFromNormalImage:@"NewGame.png" 
                                       selectedImage:@"NewGame_P.png" 
                                       disabledImage:nil 
                                       target:self 
                                       selector:@selector(displaySceneSelection)];
    
    CCMenuItemImage *creditsButton = [CCMenuItemImage 
                                      itemFromNormalImage:@"Credits.png" 
                                      selectedImage:@"Credits_P.png" 
                                      disabledImage:nil 
                                      target:self 
                                      selector:@selector(showCredits)];
    
    CCMenuItemImage *optionsButton = [CCMenuItemImage 
                                      itemFromNormalImage:@"Settings.png" 
                                      selectedImage:@"Settings_P.png" 
                                      disabledImage:nil 
                                      target:self 
                                      selector:@selector(showOptions)];
    
    /*CCMenuItemImage *continueButton = [CCMenuItemImage 
                                      itemFromNormalImage:@"Continue.png" 
                                      selectedImage:@"Continue_P.png" 
                                      disabledImage:nil 
                                      target:self 
                                      selector:@selector(showOptions)];*/
    
    CCMenuItemImage *HighScoresButton = [CCMenuItemImage 
                                      itemFromNormalImage:@"HighScores.png" 
                                      selectedImage:@"HighScores_P.png" 
                                      disabledImage:nil 
                                      target:self 
                                      selector:@selector(showScores)];
    
    mainMenu = [CCMenu 
                menuWithItems:playGameButton,optionsButton
                ,HighScoresButton,creditsButton,nil];
    [mainMenu alignItemsVerticallyWithPadding:screenSize.height * 0.059f];
    [mainMenu alignItemsInColumns:
     [NSNumber numberWithUnsignedInt:2],
     [NSNumber numberWithUnsignedInt:2],
     nil
     ];
    [mainMenu setPosition:
     ccp(screenSize.width * 2.0f,
         screenSize.height / 2.0f)];
    id moveAction = 
    [CCMoveTo actionWithDuration:1.2f 
                        position:ccp(screenSize.width * 1.15f,
                                     screenSize.height/2.0f)];
    id moveEffect = [CCEaseIn actionWithAction:moveAction rate:1.0f];
    [mainMenu runAction:moveEffect];
    [self addChild:mainMenu z:0 tag:kMainMenuTagValue];
}

-(void)displaySceneSelection {
    CGSize screenSize = [CCDirector sharedDirector].winSize; 
    if (mainMenu != nil) {
        [mainMenu removeFromParentAndCleanup:YES];
    }
    
    CCLabelBMFont *playScene1Label = 
    [CCLabelBMFont labelWithString:@"Level 1" 
                           fntFile:@"VikingSpeechFont64.fnt"];
    CCMenuItemLabel *playScene1 = 
    [CCMenuItemLabel itemWithLabel:playScene1Label target:self 
                          selector:@selector(playScene:)];
    [playScene1 setTag:1];
    
    CCLabelBMFont *playScene2Label = 
    [CCLabelBMFont labelWithString:@"Level 2" 
                           fntFile:@"VikingSpeechFont64.fnt"];
    CCMenuItemLabel *playScene2 = 
    [CCMenuItemLabel itemWithLabel:playScene2Label target:self 
                          selector:@selector(playScene:)];
    [playScene2 setTag:2];
    
    CCLabelBMFont *playScene3Label = 
    [CCLabelBMFont labelWithString:@"Level 3" 
                           fntFile:@"VikingSpeechFont64.fnt"];
    CCMenuItemLabel *playScene3 = [CCMenuItemLabel itemWithLabel:playScene3Label target:self 
                                                        selector:@selector(playScene:)];
    [playScene3 setTag:3];
        
    CCLabelBMFont *backButtonLabel = 
    [CCLabelBMFont labelWithString:@"Back" 
                           fntFile:@"VikingSpeechFont64.fnt"];
    CCMenuItemLabel *backButton = 
    [CCMenuItemLabel itemWithLabel:backButtonLabel target:self 
                          selector:@selector(displayMainMenu)];
    
    // Get the stored data before the view loads
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    bool *isLevel1Complete = [defaults boolForKey:@"isLevel1Complete"];
    bool *isLevel2Complete = [defaults boolForKey:@"isLevel2Complete"];
    
    if(isLevel2Complete)
        sceneSelectMenu = [CCMenu menuWithItems:playScene1,playScene2,playScene3,backButton,nil];
    else if (isLevel1Complete)
        sceneSelectMenu = [CCMenu menuWithItems:playScene1,playScene2,backButton,nil];
    else
        sceneSelectMenu = [CCMenu menuWithItems:playScene1,backButton,nil];
    
    
    [sceneSelectMenu alignItemsVerticallyWithPadding:screenSize.height * 0.059f];
    [sceneSelectMenu setPosition:ccp(screenSize.width * 2, 
                                     screenSize.height / 2)];
    
    id moveAction = [CCMoveTo actionWithDuration:0.5f 
                                        position:ccp(screenSize.width * 1.0f, 
                                                     screenSize.height/2)];
    id moveEffect = [CCEaseIn actionWithAction:moveAction rate:1.0f];
    [sceneSelectMenu runAction:moveEffect];
    [self addChild:sceneSelectMenu z:1 tag:kSceneMenuTagValue];
}
-(id)init {
    self = [super init];
    if (self != nil) {
        CGSize screenSize = [CCDirector sharedDirector].winSize; 
        
        CCSprite *background = 
        [CCSprite spriteWithFile:@"MainMenuBackground.png"];
        [background setPosition:ccp(screenSize.width/2, 
                                    screenSize.height/2)];
        [self addChild:background];
        [self displayMainMenu];
        
        CCSprite *caraZombie = 
        [CCSprite spriteWithFile:@"cara.png"];
        [caraZombie setPosition:ccp(screenSize.width * 0.01f, 
                                screenSize.height * 0.85f)];
        [self addChild:caraZombie];
        
        id rotateAction = [CCEaseElasticInOut actionWithAction:
                           [CCRotateBy actionWithDuration:5.5f 
                                                    angle:360]];
        
        id scaleUp = [CCScaleTo actionWithDuration:2.0f scale:1.5f];
        id scaleDown = [CCScaleTo actionWithDuration:2.0f scale:0.5f];
        
        [caraZombie runAction:[CCRepeatForever actionWithAction:
                           [CCSequence 
                            actions:scaleUp,scaleDown,nil]]];
        
        [caraZombie runAction:
         [CCRepeatForever actionWithAction:rotateAction]];
        
        [[GameManager sharedGameManager] playBackgroundTrack:BACKGROUND_TRACK_MAIN_MENU];
    }
    return self;
}
@end

