//
//  GameManager.h
//  Viral Zombies TD
//
//  Created by Yo on 03/11/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//


#import <Foundation/Foundation.h>
#import "Constants.h"
#import "SimpleAudioEngine.h"

@interface GameManager : NSObject {
    int currentLevel;
    BOOL isMusicON;
    BOOL isSoundEffectsON;
    BOOL hasPlayerDied;
    int difficulty;
    SceneTypes currentScene;
    
    // Added for audio
    BOOL hasAudioBeenInitialized;
    GameManagerSoundState managerSoundState;
    SimpleAudioEngine *soundEngine;
}
@property (readwrite) int currentLevel;
@property (readwrite) BOOL isMusicON;
@property (readwrite) BOOL isSoundEffectsON;
@property (readwrite) BOOL hasPlayerDied;
@property (readwrite) int difficulty;
@property (readwrite) GameManagerSoundState managerSoundState;


+(GameManager*)sharedGameManager;                                  // 1
-(void)runSceneWithID:(SceneTypes)sceneID;                         // 2
-(void)openSiteWithLinkType:(LinkTypes)linkTypeToOpen ;            // 3
-(void)setupAudioEngine;
-(void)playSoundEffect:(NSString*)soundEffectKey;
-(void)playBackgroundTrack:(NSString*)trackFileName;
-(void)stopBackgroundTrack;
@end
