//
//  DataModel.h
//  Cocos2D Build a Tower Defense Game
//
//  Created by iPhoneGameTutorials on 4/4/11.
//  Copyright 2011 iPhoneGameTutorial.com All rights reserved.
//

#import "cocos2d.h"
#import "Goal.h"

@interface DataModel : NSObject <NSCoding> {
	CCLayer *_gameLayer;
	CCLayer *_gameHUDLayer;
	CCSprite *_gameGoal;
	
	NSMutableArray *_projectiles;
	NSMutableArray *_towers;
	NSMutableArray *_targets;	
	NSMutableArray *_waypoints;	
	int _currentScore;
	int _currentCoins;
	int _currentHP;
	bool _levelComplete;
	
	NSMutableArray *_waves;	
	
	UIPanGestureRecognizer *_gestureRecognizer;
}

@property (nonatomic, retain) CCLayer *_gameLayer;
@property (nonatomic, retain) CCLayer *_gameHUDLayer;
@property (nonatomic, retain) CCSprite *_gameGoal;

@property (nonatomic, retain) NSMutableArray * _projectiles;
@property (nonatomic, retain) NSMutableArray * _towers;
@property (nonatomic, retain) NSMutableArray * _targets;
@property (nonatomic, retain) NSMutableArray * _waypoints;
@property (nonatomic, assign) int _currentScore;
@property (nonatomic, assign) int _currentCoins;
@property (nonatomic, assign) int _currentHP;
@property (nonatomic, assign) bool _levelComplete;

@property (nonatomic, retain) NSMutableArray * _waves;

@property (nonatomic, retain) UIPanGestureRecognizer *_gestureRecognizer;
+ (DataModel*)getModel;
- (void)reset;

@end
